﻿using System.Windows.Forms;

namespace MapToolTipSample
{
    class MapToolTip
    {
        public delegate void TimeChangedDelegate(int startDelay, int displayTime);
        public event TimeChangedDelegate TimeChanged;

        private int startDelay = 1;
        private int displayTime = 1;

        public Timer ToolTipTimer { get; set; }
        public Timer RemoveToolTipTimer { get; set; }
        public int XOffset { get; set; }
        public int YOffset { get; set; }
        public string LayerName { get; set; }
        public string FieldName { get; set; }
        public Control HoverControl { get; set; }

        public int StartDelay
        {
            get
            {
                return startDelay;
            }
            set
            {
                startDelay = value;
                TimeChanged(value, displayTime);
            }
        }
        public int DisplayTime
        {
            get
            {
                return displayTime;
            }
            set
            {
                displayTime = value;
                TimeChanged(startDelay, value);
            }
        }

        public MapToolTip()
        {
            XOffset = 0;
            YOffset = 20;
            ToolTipTimer = new Timer();
            RemoveToolTipTimer = new Timer();
            TimeChanged += new TimeChangedDelegate(MapToolTip_TimeChanged);
        }

        void MapToolTip_TimeChanged(int startDelay, int displayTime)
        {
            ToolTipTimer.Interval = startDelay;
            RemoveToolTipTimer.Interval = displayTime;
        }
    }
}
